$transition-time: 2.3s;
$border-radius: .3em;
$card-width: 12em;
$text-shadow: #1D1B18 1px 1px 1px;
$border-image: linear-gradient(23deg, red, orange, yellow, green, blue, indigo, violet) 1;

.search {
  &_form {
    &_field {
      min-width: 24em;
      margin: 0 2em;
    }
  }
}

.stretch {
  flex-grow: 1;
  height: 100%;

  .searchResult {
    display: flex;
    flex-wrap: wrap;
    gap: 1em;
    align-items: center;
    justify-content: space-around;
    overflow-y: auto;

    .set {
      position: relative;
      height: 9em;
      width: 12em;
      border: .1em solid rgba(255, 255, 255, .5);
      border-radius: $border-radius;
      transition: ease all $transition-time;
      perspective: 1000px;
      transition-delay: 5s;

      &:hover {
        .cover {
          transform: rotateX(0deg) rotateY(-180deg);
          border-radius: $border-radius;

          .set_number {
            transform: scale(0);
          }

          .setPartCount {
            transform: scale(0);
          }

          button {
            transform: rotatey(-180deg);
          }
        }
      }

      .cover {
        position: absolute;
        height: 9em;
        width: $card-width;
        border-radius: $border-radius;

        transform-style: preserve-3d;
        transition: ease all $transition-time;
        background-size: cover;
        background-position: center center;
        background-repeat: no-repeat;

        &:before {
          content: '';
          position: absolute;
          border: .2em solid;
          border-image: $border-image;
          top: .3em;
          left: .3em;
          right: .3em;
          bottom: .3em;
          z-index: 2;
          transition: ease all $transition-time;
          transform-style: preserve-3d;
        }

        &:after {
          content: '';
          position: absolute;
          top: 0;
          left: 0;
          right: 0;
          bottom: 0;
          z-index: 2;
          transition: ease all 1.3s;
          background: rgba(0, 0, 0, .1);
        }

        .set_number {
          position: absolute;
          text-shadow: $text-shadow;
          bottom: $border-radius;
          left: $border-radius;
          color: white;
          transform-style: preserve-3d;
          transition: ease all $transition-time;
          z-index: 3;
          transform: translateZ(12px);
        }

        .setPartCount {
          position: absolute;
          text-shadow: $text-shadow;
          top: $border-radius;
          right: $border-radius;
          color: white;
          border-radius: $border-radius;
          padding: .4em .8em;
          transition: ease all $transition-time;
          z-index: 4;
          transform: translateZ(0px);
        }
      }

      .card-back {
        position: absolute;
        border-radius: $border-radius;
        height: 100%;
        width: 100%;
        background: #0b0f08;
        transform-style: preserve-3d;
        transition: ease all $transition-time;
        transform: translateZ(-1px);

        .set_title, .set_parts {
          transform-style: preserve-3d;
          transition: ease transform $transition-time, ease background .5s;
          transform: rotateY(-180deg);
          background: transparent;
          border: 1px solid;
          border-image: $border-image;
          color: white;
          position: absolute;
        }

        .set_title {
          bottom: .3em;
          right: .3em;
          width: calc($card-width - .2em);
          margin: .2em;
        }

        .set_parts {
          top: .3em;
          left: .3em;
        }
      }
    }
  }
}
